import java.lang.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.servlet.*;

import sun.server.html.*;

/**
 * @author  Pavani Diwanji
 */
public
class PhoneServlet extends Servlet { 
    private Hashtable phones;

    public void init() {
        int next;
        String name, number;

        log("PhoneServlet.initialize: enter");

        String fileName = getInitParameter("phonelist");
	if (fileName == null) {
	    return;
	}

        log("PhoneServlet.initialize: filename = " + fileName);

	try {
	    FileInputStream fin = new FileInputStream(fileName);
	    phones = new Hashtable();
	    StreamTokenizer st = new StreamTokenizer(fin);
	    st.eolIsSignificant(true);
	    st.slashSlashComments(true);

	    while ((next = st.nextToken()) != StreamTokenizer.TT_EOF) {
		switch (next) {
		  case StreamTokenizer.TT_WORD:
		    name = st.sval;
		    next = st.nextToken();
		    if (next != StreamTokenizer.TT_WORD) {
			throw new IOException("No phone for name: " + name);
		    }
		    number = st.sval;
		    break;
		  default:
		    continue;
		}
		phones.put(name, number);        
	    }
	} catch (IOException e) {
	    phones = null;
	}
    }

    public void service(ServletRequest req, ServletResponse res)
	throws Exception
    {
	/*
	 * If the query is for a specific person then just return, else
	 * dump the whole extensions list
	 */
	res.setContentType("text/html");
	res.writeHeaders();
	OutputStream out = res.getOutputStream();
	String title = "Phones";

	HtmlPage page = new HtmlPage(title);
	page.addTagPair("H1", title);
   
	if (phones == null) {
	    page.addText("No phone list");
	    page.write(out);
	    out.flush();
	    return;
	}
	String queryString = req.getQueryString();
	if (queryString != null) {
	    String name = queryString.substring(queryString.indexOf("name=")+5);
	    if (name != null) {
		String phone = (String) phones.get(name);
		if (phone == null) phone = "Not listed";
		page.addText(name + ": " + phone);
		page.write(out);
		out.flush();
		return;
	    }
	}
	page.addText(phones.toString());
	page.write(out);
	out.flush();
    }

    public String getServletInfo() {
	return "This servlet is useful for looking up phone extensions.";
    }
}
